#!/usr/bin/python

# bounce 0.1
#
# This package allows Mozilla/Netscape users to use the "bounce"
# feature known from other email clients such as mutt.
#
# Usage:
# After installing bounce, open a mail you want to bounce, click
# the forward mail button (mail must be forwarded as attachment),
# set To: field to "bounce@localhost" and put the recipient of the
# bounced mail into the Reply-To: field.


# bounce 0.1
# Copyright (c) 2003  Hans-Georg Esser <h.g.esser@gmx.de>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import sys
from string import split, join
from re import match
import readline


# BEGIN function splitmail(s)

def splitmail(s):
    # this function splits e-mail addresses of either of the
    # three forms
    #   1)  Name Name Name <name@name.name>
    #   2)  name@name.name (Name Name Name)
    #   3)  name@name.name
    # into separate strings for sender name and mail address.
    # In case where only an address was given, this will be
    # returned twice.
    try:
        # is it case 1) ?
        s1,s2 = split(s," <")
        s2 = s2[:-1]
    except:
        try:
            # is it case 2) ?
            s2,s1 = split(s," (")
            s1 = s1[:-1]
        except:
            # must be case 3) then.
            s1 = s
            s2 = s
    return s1,s2

# END function splitmail(s)


# BEGIN main


# read mail from stdin and initialize some variables

input=sys.stdin.readlines()
from1found=0
from2found=0
boundfound=0
to1found=0
to2found=0
reply1found=0


# Step 1:
# find the to:, cc: and reply-to: fields of the outer mail and
# the forwarded mail (the attachment)

for line in input:
    parts = split(line)

    if parts != [] and parts[0] == "From:":
        if not from1found:
            from1 = join(parts[1:])
            from1found = 1
        else:
            if not from2found:
                from2 = join(parts[1:])
                from2found = 1

    if parts != [] and parts[0] == "To:":
        if not to1found:
            to1 = join(parts[1:])
            to1found = 1
        else:
            if not to2found:
                to2 = join(parts[1:])
                to2found = 1

    if parts != [] and parts[0] == "Reply-To:":
        if not reply1found:
            reply1 = join(parts[1:])
            reply1found = 1

    parts = split(line,'"')
    if parts != [] and parts[0] == " boundary=" and not boundfound:
        boundary = parts[1]
        boundfound = 1
        
    
    

#print "From1: "+from1
#print "From2: "+from2
#print "From:  "+from2+" (by way of "+from1+")"
#print "To1:   "+to1
#print "To2:   "+to2
#print "Cc1:   "+reply1
#print
#print "Boundary: "+boundary
#print


beginfound=0
for line in input[2:]:
    parts = split(line)
    if parts != [] and parts[0] == "Return-path:": beginfound = 1
    if beginfound and line != "--"+boundary+"--\n":
        if parts != [] and parts[0] == "User-Agent:": print "X-Annotation: Bounced by bounce.py"
        if parts != [] and parts[0] == "From:":
            n1,a1 = splitmail(from1)
            n2,a2 = splitmail(from2)
            print "From: "+n2+" (by way of "+n1+") <"+a2+">"
        else:
            if parts != [] and parts[0] == "To:":
                print "To: "+reply1
                print "Apparently-To: "+to2
            else:
                print line,


# END main
